library fields.default_transforms;

import 'field_transform.dart';

num _int2num(int value) => value;

int _num2int(num value) => value.toInt();

int _string2int(String value) {
  try {
    return int.parse(value);
  } on FormatException catch(e) {
    throw new FieldTransformError(cause: e);
  }
}

double _string2double(String value) {
  try {
    return double.parse(value);      
  } on FormatException catch(e) {
    throw new FieldTransformError(cause: e);
  }
}

void registerDefaultFieldTransforms() {  
  FieldTransform.register(const FieldTransform<int, num>(_int2num));
  FieldTransform.register(const FieldTransform<num, int>(_num2int));
  FieldTransform.register(const FieldTransform<String, int>(_string2int));
  FieldTransform.register(const FieldTransform<String, double>(_string2double));
}
